//! # Events helper
//!
//! @author Pierre Hubert



use crate::data::error::Res;
use crate::data::conversation_message::ConversationMessage;
use crate::controllers::conversations_controller;

pub enum Event<'a> {

    /// Created a new conversation message
    NewConversationMessage(&'a ConversationMessage),

    /// Updated conversation message
    UpdatedConversationMessage(&'a ConversationMessage),

    /// Deleted a conversation message
    DeleteConversationMessage(&'a ConversationMessage),

    /// No event
    None,
}

/// Propagate an event through the different components of the application
pub fn propagate_event(e: &Event) -> Res {
    conversations_controller::handle_event(e)?;
    Ok(())
}